pro checkunit
;;;; check if the units of the standars are indeed in units of electrons/s
;;;; answer is yes for rectified*.fits


fluxpath='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/LONGSLIT-46x4/2013dec24/K/'
fluxrootname='rectified_Flux_K_Feige15_K_A-B_0219-0220';  'longslit_131225_flux_arcAr_Feige15_K_A-B' 

fits_read,fluxpath+fluxrootname+'.fits',feige15,hrd1

fluxpath='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/Feb2014/LONGSLIT-15x4/Flux_standards/2014feb11/K/'
fluxrootname='rectified_longslit-Flux_HIP24508_K_A-B_0215-0216';  'longslit_131225_flux_arcAr_Feige15_K_A-B' 
fits_read,fluxpath+fluxrootname+'.fits',hip245,hrd2

ct_feige=total(feige15[148:2187,1019:1029])
ct_hip245=total(hip245[148:2187,998:1020])

mag_feige=10.268
mag_hip245=8.654
ctf_feige=10^(-0.4*mag_feige)
ctf_hip245=10^(-0.4*mag_hip245)

ctc_ratio=ct_feige/ct_hip245
ctf_ratio=ctf_feige/ctf_hip245
ctx_ratio=ct_feige/(29.0958)/(ct_hip245/(14.5479))

print,ctc_ratio
print,ctf_ratio
print,ctx_ratio

stop

end
