pro coadd2d_offset
device, decomposed=0
loadcolors




path1='/Volumes/backup/zfire16/FEB2016/AGEIS_mask1/2016feb26/K/'
path2='/Volumes/backup/zfire16/FEB2016/AGEIS_mask1/2016feb27/K/'


;brightname1='shallowmask2_K_K_S26_AGN_BCG_D2_7910_eps_t_fc.fits';'eps_K_m140212_0164-0202_S27_t_fc.fits' ;; use star/bright galaxy frames to derive the spatial shift 
;brightname2='shallowmask2_K_K_S26_AGN_BCG_D2_7910_eps_t_fc.fits';'eps_K_m140213_0343-0367_S27_t_fc.fits'

brightname1='AGEIS_mask1_K_S12_S34734_eps_t_fc.fits'
brightname2=brightname1


be1='AGEIS_mask1_K_S12_S34734_eps_t_sdev_fc.fits'
be2=be1




f1=path1+brightname1
f2=path2+brightname2

      fits_read,f1,image1,header_obj1,exten_no=0
      fits_read,f2,image2,header_obj2,exten_no=0


      spec1d_d=total(image1,2,/nan)
      wavelen_obj=getwlcd(spec1d_d,header_obj1)   ;;; moircsfire 

      
image1=image1/1.e-17
image2=image2/1.e-17

f1e=path1+be1
f2e=path2+be2

      fits_read,f1e,image1e,header_obj1e,exten_no=0
      fits_read,f2e,image2e,header_obj2e,exten_no=0

image1e=image1e/1.e-17
image2e=image2e/1.e-17


image1var=image1e^2
image2var=image2e^2

;;  spec1d_dattt=total(image1,2,/nan)
;;   wavedat=getwlcd(spec1d_dattt,header_obj1)   ;;; moircsfire 
;; ok=where(wavedat gt 20283. and wavedat le 20317.)


sz1=size(image1)  & sz2=size(image2)
if sz1[1] ne sz2[1] or sz1[2] ne sz2[2] then print, '  images have different sizes !!!!'
image1=image1[200:sz1[1]-400,1:sz1[2]-2]
image2=image2[200:sz1[1]-400,1:sz1[2]-2]

image1var=image1var[200:sz1[1]-400,1:sz1[2]-2]
image2var=image2var[200:sz1[1]-400,1:sz1[2]-2]

;;
;;
;image1=image1[984:1004,1:sz1[2]-2]
;image2=image2[984:1004,1:sz1[2]-2]


result = correl_images(image1,image2)
corrmat_analyze,result,xoffset,yoffset
;correl_optimize,image1,image2,xoffset,yoffset

print,xoffset,yoffset,' --- offset of'+brightname2+'...with resp. to the first image'+brightname1



  spec2dcut=image1 ;[where(wavex ge lowcut and wavex le hicut),*]
  spec2dcutvar=image1var ;[where(wavex ge lowcut and wavex le hicut),*]

  space_profile=median(spec2dcut,dimension=1)
  plot,space_profile,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut=space_profile[x-10:x+10]
  xarray=findgen(21)-10.
  yfit=mpfitpeak(xarray,space_profile_cut,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray,space_profile_cut,psym=10;,xtickformat='(A1)'
  oplot,xarray,yfit,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  spec2d_cut=spec2dcut[*,cen-width:cen+width]
  spec1d1=total(spec2d_cut,2,/nan);/1.d-17
  cens=62 ; center of sky line extraction
 spec2d_cut_sky1=spec2dcut[*,cens-width:cens+width]
  spec1d1_sky1=total(spec2d_cut_sky1,2,/nan);/1.d-17

  spec2d_cutvar=spec2dcutvar[*,cen-width:cen+width]
  spec1d1var=total(spec2d_cutvar,2,/nan);/1.d-17
 cen1=cen

 spec2dcut=image2;[where(wavex ge lowcut and wavex le hicut),*]
 spec2dcutvar=image2var;[where(wavex ge lowcut and wavex le hicut),*]

  space_profile=median(spec2dcut,dimension=1)
  plot,space_profile,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut=space_profile[x-10:x+10]
  xarray=findgen(21)-10.
  yfit=mpfitpeak(xarray,space_profile_cut,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray,space_profile_cut,psym=10;,xtickformat='(A1)'
  oplot,xarray,yfit,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  spec2d_cut=spec2dcut[*,cen-width:cen+width]
  spec1d2=total(spec2d_cut,2,/nan);/1.d-17
cen2=cen
 spec2d_cutvar=spec2dcutvar[*,cen-width:cen+width]
  spec1d2var=total(spec2d_cutvar,2,/nan);/1.d-17

  cens=cens
 spec2d_cut_sky2=spec2dcut[*,cens-width:cens+width]
  spec1d1_sky2=total(spec2d_cut_sky2,2,/nan);/1.d-17

lag_max=ccpeak(spec1d1_sky1,spec1d1_sky2)
  plot,spec1d1/spec1d2,title=' path1 / path2'
  print,'y-spatial offset, cen_path,  cen_path2=, c ',cen1, cen2
    print,'x-spatial offset, path2 array need to move ', lag_max

  window,2
  plot, wavelen_obj,spec1d1_sky1,xran=[21100.,21600.],/xs
 ; oplot,wavelen_obj,spec1d1_sky2*0.89, color=2
  oplot,wavelen_obj+lag_max*(wavelen_obj[1]-wavelen_obj[0]),spec1d1_sky2*0.89, color=3

 


  
print,'median flux of path1 / path2',median(spec1d1[200:n_elements(spec1d1)-200])/median(spec1d2[200:n_elements(spec1d1)-200])
snratio=total(spec1d1)/sqrt(total(spec1d1var))/(total(spec1d2)/sqrt(total(spec1d2var)))
print,'  SN ratio of path1 / path 2', snratio
print,'percentage median flux of path1 / path2s',abs(median(spec1d1)-median(spec1d2))/max([median(spec1d1),median(spec1d2)])

;coaddimage=(image1+frac_pix_shift(image2,xoffset,yoffset))/2

;mwrfits,coaddimage,path+'test.fits',header_obj2
;; results
;;; offset = 0 for all nights !!!!!!!!!!!
stop
end



;pro fit1dmos_flux,path,pathdat,maskname,intab,maskroot,maskroot_var,textpos,ps=ps,first=first


;;mask3
;eps_K_m131225_0543-0561_S03_t_fc.fits
;eps_K_m131224_0403-0421_S16_t_fc.fits       
pro add2d
;;;; 
;path2='/Users/yuantt/work/data/MOSFIRE/catlg/Feb2014/archive/Masks_120314_oldDRP/Hbandmask1/2014feb12/'
;path1='/Users/yuantt/work/data/MOSFIRE/catlg/Feb2014/archive/Masks_120314_oldDRP/Hbandmask1/2014feb10/'

;path2='/Users/yuantt/work/data/MOSFIRE/catlg/Feb2014/archive/Masks_120314_oldDRP/KbandLargeArea3/2014feb13/'
;path1='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/shallowmask1_v3/2013dec25/K/'
;path2='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/shallowmask1_v3/2013dec24/K/'



path1='/Volumes/backup/zfire16/FEB2016/AGEIS_mask1/2016feb26/K/'
path2='/Volumes/backup/zfire16/FEB2016/AGEIS_mask1/2016feb27/K/'



;textpos='eps_H_S'
;textpos='eps_K_m140212_0164-0202_S'   ;;; unique string character in the science frame filename used to locate the slitlet ID
;textpos='eps_H_m140212_0070-0116_S'   ;;; unique string character in the science frame filename used to locate the slitlet ID

paths=[path1,path2]
masknum=1

objlist_fc_nt1=path1+'obj_t_fc.list'
objlist_std_nt1=path1+'obj_sdev_t_fc.list' 
objlist_fc_nt2=path2+'obj_t_fc.list'
objlist_std_nt2=path2+'obj_sdev_t_fc.list' 

readcol,objlist_fc_nt1,fxx_nt1,format='a'   ;; object list ;; electron/s
readcol,objlist_std_nt1,fxx_nt1_std,format='a'   ;; object list ;; electron/s
readcol,objlist_fc_nt2,fxx_nt2,format='a'   ;; object list ;; electron/s
readcol,objlist_std_nt2,fxx_nt2_std,format='a'   ;; object list ;; electron/s




xoff=[0,0] & yoff=[0,0]

norm_fluxf1=0   ;, ie. use path2 as standard
norm_fluxf2=1   ;, ie. use path1 as standard

fluxf1=1/0.4 ;;;  if use the factor on path 1, path1*fluxf1 i.e., use path2 as standard
fluxf2=0.70  ;3.864 ;  ;; if factor used on night 2,path2*fluxf2, ie. use path1 as standard, e.g.,flux of path1 / path2      0.8865412 <-
mu=0.986 ;sn1/sn2
;;;; 

for moi = 0, masknum-1 do begin
print,'  coadd mask  -' 


fileno = n_elements(fxx_nt1)
         for noi=0, fileno-1 do begin
ppos1=0
ppos2=strpos(fxx_nt1[noi],'.fits')
Namefxx_nt1=strmid(fxx_nt1[noi],ppos1,ppos2-ppos1)

ppos1=0
ppos2=strpos(fxx_nt1_std[noi],'.fits')
Namefxx_nt1_std=strmid(fxx_nt1_std[noi],ppos1,ppos2-ppos1)

     fits_read,fxx_nt1[noi],image_nt1,hdr,exten_no=0
     fits_read,fxx_nt1_std[noi],image_nt1_std,hdrv,exten_no=0

textpos='_K_S'
stlen1=strlen(textpos)
           pppos1=strpos(fxx_nt1[noi],textpos)
           slitnum_st=strmid(fxx_nt1[noi],pppos1+stlen1,2)


;stop
           slitnum=STR2NUM(slitnum_st)*1
               slitnum_compare=strmid(fxx_nt2[noi],pppos1+stlen1,2)

                matchid=where(slitnum_compare eq slitnum,ct1)
if ct1 ne 1 then stop
        ;           if ct1 gt 0 then begin
                     ;    fits_read,fxx_nt2[matchid[0]],image_nt2,hdr2,exten_no=0
                     ;    fits_read,fxx_nt2_std[matchid[0]],image_nt2_std,hdrv2,exten_no=0
                         fits_read,fxx_nt2[noi],image_nt2,hdr2,exten_no=0
                         fits_read,fxx_nt2_std[noi],image_nt2_std,hdrv2,exten_no=0
                     
                       xoffset=xoff[moi] & yoffset=yoff[moi]
                       if xoffset ge 1 or yoffset ge 1 then begin
                           image_nt2=frac_pix_shift(image_nt2,xoffset,yoffset)
                           image_nt2_std=frac_pix_shift(image_nt2_std,xoffset,yoffset)
                        endif

;;; CHECK IF TWO NIGHTS'  DATA HAVE THE SAME SIZES
sz1=size(image_nt1)  & sz2=size(image_nt2)
if sz1[1] ne sz2[1] or sz1[2] ne sz2[2] then begin
   print, '  images have different sizes !!!!'
   print, noi, Namefxx_nt1
stop
endif

 if norm_fluxf1 eq 1 then begin
                           imagecoadd=(image_nt1*fluxf1+image_nt2)/2.
                           imagecoadd_std=sqrt((image_nt1_std*fluxf1)^2+(image_nt2_std)^2)/2.
                          
                        endif


 if norm_fluxf2 eq 1 then begin
                     ;; ;no weighting
               ;           imagecoadd=(image_nt1+image_nt2*fluxf2)/2.
               ;            imagecoadd_std=sqrt((image_nt1_std)^2+(image_nt2_std*fluxf2)^2)/2.
 ;;;; weighting 
;mu=1.
                           imagecoadd=(image_nt1*(mu/(1.+mu))+image_nt2*fluxf2*(1./(1.+mu)))/1.
                           imagecoadd_std=sqrt((image_nt1_std*(mu/(1.+mu)))^2+(image_nt2_std*fluxf2*(1./(1.+mu)))^2)/1
 
 

   endif


        mwrfits,imagecoadd,Namefxx_nt1+'_coadd.fits',hdr,/create
        mwrfits,imagecoadd_std,Namefxx_nt1_std+'_coadd.fits',hdr,/create

                   ;; endif else begin
                   ;;  print,' stopped ---> no object matching the multiple observations '
                   ;;  stop
                   ;; endelse 


         endfor
endfor 

print,'  -- end'
stop
end

