pro divid_flux,datapath,fluxpath,bbname,bbname_wave,objlist,objlist_std,fluxconvt,usespec=usespec,poly=poly
;;;;  divide all science data by the sensitivty curve derived from
 ;;;; cali_telluric_flux.pro 
;;;; i.e, use this results
;;;; 
;;;;  Note this program use spawn,'rm -rf '+path+'*_fc.fits'   ;;; THIS WILL REMOVE ALL FILES THAT ENDS WITH *_FC.FITS, BE CAREFUL !
;;; program called moscali_flux


;;; ;;;;   CHANGE THE PATH HERE  ;;;;;;;;;;;;;;;;;;
;path='/Users/yuantt/work/data/MOSFIRE/catlg/mask2_combined/shallowmask1_v3/'   ;;; path for data to be flux calibrated, need to be telluric corrected first
path=datapath;'/Users/yuantt/work/data/MOSFIRE/catlg/mask2_combined/'   ;;; path for data to be flux calibrated, need to be telluric corrected firs
fluxpath=fluxpath;'/Users/yuantt/work/data/MOSFIRE/catlg/codesample/'  ;; path where the following two files are
;;bbname='flux_1D_HdyrmBB.fits'
;;bbname_wave='flux_1D_HdyrmBB_wave.fits'
;;; check how bbname is craeted
;datarootname=datarootname


readcol,objlist,fxx,format='a'   ;; object list ;; electron/s
readcol,objlist_std,fxx_sdev,format='a'   ;;; standard deviation list ;; electron/s


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; NO NEED TO CHANGE SECTION ;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; BELOW;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



fileno = n_elements(fxx)
fileout1=fxx
fileout2=fxx

     fits_read,fxx[0],scube0,header_obj,exten_no=0
     spec1d_d=total(scube0,2,/nan)
     wavelen_obj=getwlcd(spec1d_d,header_obj)   ;;; moircsfire 



;; ;;; check for flux calibration BEGIn
;;  flux1d_rebin=interpol(flux1d,wavelen_star,wavelen_obj) ; linear interpol without any options
;;  ind=where (flux1d_rebin eq 0,ctt)
;; if ctt gt 0 then flux1d_rebin[ind]=!values.f_nan

;; flux1d_rebin=median(flux1d_rebin,15)

;; scale_lam_b=flux1d_rebin[*]/fluxconvt   ;;;photometry
;; wave_b=wavelen_star

;; writefits,fluxpath+'flux_1D_scale_broad.fits',scale_lam_b
;; writefits,fluxpath+'flux_1D_scale_lam_broad.fits',wave_b
;; ;;;fluxconvt=(exposure_star/gain)*j_flux/bb_j
;; plot,wave_b,scale_lam_b,ytitle='Flux conversion factor',yra=[0,1.5e17],/ys,charsize=2
;; fits_read,fluxpath+'flux_1D_scale.fits',scale_lam
;; fits_read,fluxpath+'flux_1D_scale_lam.fits',wave
;; oplot,wave,scale_lam,color=2
;; stop
;; ;;; check for flux calibration END






IF (~defined(usespec)) then begin


bbname=bbname
bbname_wave=bbname_wave
fits_read,fluxpath+bbname,flux1d,hd1d
fits_read,fluxpath+bbname_wave,wavelen_star,hd1d


;;;;;;; some manual work to push the Kband edge to 2.4um
;; man=where(wavelen_obj gt 23900. AND wavelen_obj le 24000.)
;; man1=where(wavelen_obj le 23900. AND wavelen_obj gt 23890)
;; manual=median(flux1d[man1])
;; flux1d[man] = manual
man=where(wavelen_obj gt 23900. AND wavelen_obj le 24000.,ct1)
man1=where(wavelen_obj le 23900. AND wavelen_obj gt 23890,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(flux1d[man1])
flux1d[man] = manual
endif
man=where(wavelen_obj gt 19200. AND wavelen_obj le 19599.,ct1)
man1=where(wavelen_obj le 19630. AND wavelen_obj gt 19599,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(flux1d[man1])
flux1d[man] = manual
endif

;;; FOr band H
man=where(wavelen_obj gt 17949. AND wavelen_obj le 18210.,ct1)
man1=where(wavelen_obj le 17949. AND wavelen_obj gt 17926,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(flux1d[man1])
flux1d[man] = manual
endif

man=where(wavelen_obj gt 14501 AND wavelen_obj le 14663.,ct1)
man1=where(wavelen_obj le 14750. AND wavelen_obj gt 14663,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(flux1d[man1])
flux1d[man] = manual
endif
;;;;;;; some manual work to push the Kband edge to 2.4um

 flux1d_rebin=interpol(flux1d,wavelen_star,wavelen_obj) ; linear interpol without any options

 
;;;;;;; some manual work to push the Kband edge to 2.4um




 ind=where (flux1d_rebin eq 0,ctt)
if ctt gt 0 then flux1d_rebin[ind]=!values.f_nan

flux1d_rebin=median(flux1d_rebin,25)
ffc=flux1d_rebin/fluxconvt

nanp=where(finite(ffc,/nan),cc)


if cc ge 1 then ffc[nanp]=0
;stop
plot,wavelen_obj,ffc,title='Final response curve divided to all data',thick=1

test1=where(wavelen_obj gt 15000 and wavelen_obj le 17500,cnt1)

test2=where(wavelen_obj gt 20500 and wavelen_obj le 23000,cnt2)

;IF (defined(poly)) then begin
switchon=0
if cnt1 gt 100 then begin
   switchon=1
   test=test1
   fitpol=poly_fit(wavelen_obj[test],ffc[test],2,sig=sig)
endif
if cnt2 gt 100 then begin
   switchon=1
   test=test2
   fitpol=poly_fit(wavelen_obj[test],ffc[test],2,sig=sig)
endif

if switchon eq 0 then begin
   fitpol=poly_fit(wavelen_obj,ffc,2,sig=sig)
endif

yy=fitpol[0]+fitpol[1]*wavelen_obj+fitpol[2]*wavelen_obj^2;+fitpol[3]*wavelen_obj^3
oplot,wavelen_obj,yy,color=4
ffc=yy

set_plot,'ps'
device,filename=datapath+'fluxfactor.eps',/color

plot,wavelen_obj,ffc,title='Final response curve divided to all data',thick=1
oplot,wavelen_obj,yy,color=4
device,/close
device,/encapsulated
set_plot,'x'

;ENDIF


;oplot,wavelen_obj,yy,color=4

set_plot,'ps'
device,filename=datapath+'fluxfactor.eps',/color
forprint,wavelen_obj,ffc,textout=datapath+'fluxfactor.txt'

plot,wavelen_obj,ffc,title='Final response curve divided to all data',thick=4
;oplot,wavelen_obj,yy,color=4
device,/close
device,/encapsulated
set_plot,'x'



 FOR noi=0,fileno-1 DO BEGIN
     fits_read,fxx[noi],scube,hdr,exten_no=0
          fits_read,fxx_sdev[noi],scube_sdev,hdrv2,exten_no=0
     sz2d=size(scube) & ysize=sz2d[2]
  ;;; actual flux calibration here
      for iy=0,ysize-1 do begin
        scube[*,iy]=scube[*,iy]/ffc[*];(flux1d_rebin[*]/fluxconvt)
        scube_sdev[*,iy]=scube_sdev[*,iy]/ffc[*];(flux1d_rebin[*]/fluxconvt)
;        scube_var[*,iy]=scube_var[*,iy]*(flux1d_rebin[*]/fluxconvt)^2  ;; equation for inverse variance cube
        endfor

ppos1=0;strpos(fxx[noi],'eps_')
ppos2=strpos(fxx[noi],'.fits')
Namefxx=strmid(fxx[noi],ppos1,ppos2-ppos1)


  
        mwrfits,scube,Namefxx+'_fc.fits',hdr,/create
        mwrfits,scube_sdev,Namefxx+'_sdev_fc.fits',hdr,/create
fileout1[noi]=Namefxx+'_fc.fits'
fileout2[noi]=Namefxx+'_sdev_fc.fits'

 ENDFOR
ENDIF


IF (defined(usespec)) then begin
fits_read,fluxpath+'flux_1D_scale.fits',scale_lam
fits_read,fluxpath+'flux_1D_scale_lam.fits',wave
;oplot,wave,scale_lam,color=2



;;;;;;; some manual work to push the Kband edge to 2.4um
;; man=where(wavelen_obj gt 23900. AND wavelen_obj le 24000.)
;; man1=where(wavelen_obj le 23900. AND wavelen_obj gt 23890)
;; manual=median(scale_lam[man1])
;; scale_lam[man] = manual
man=where(wavelen_obj gt 23900. AND wavelen_obj le 24000.,ct1)
man1=where(wavelen_obj le 23900. AND wavelen_obj gt 23890,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(scale_lam[man1])
scale_lam[man] = manual
endif

man=where(wavelen_obj gt 19200. AND wavelen_obj le 19599.,ct1)
man1=where(wavelen_obj le 19630. AND wavelen_obj gt 19599,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(scale_lam[man1])
scale_lam[man] = manual
endif

;;; FOr band H
man=where(wavelen_obj gt 17949. AND wavelen_obj le 18210.,ct1)
man1=where(wavelen_obj le 17949. AND wavelen_obj gt 17926,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(scale_lam[man1])
scale_lam[man] = manual
endif
man=where(wavelen_obj gt 14501 AND wavelen_obj le 14663.,ct1)
man1=where(wavelen_obj le 14750. AND wavelen_obj gt 14663,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(scale_lam[man1])
scale_lam[man] = manual
endif

;;;;;;; some manual work to push the Kband edge to 2.4um



 scale_rebin=interpol(scale_lam,wave,wavelen_obj) ; linear interpol without any options

 scale_rebin=smooth(scale_rebin,20)
;stopcale_rebin

;;  set_plot,'x'
;; plot,wavelen_obj,scale_rebin
;;  stop
 
set_plot,'ps'
device,filename=datapath+'fluxfactor.eps',/color
plot,wavelen_obj,scale_rebin,title='Final response curve divided to all data' ,charsize=2,thick=1;,thick=1
forprint,wavelen_obj,scale_rebin,textout=datapath+'fluxfactor.txt'

device,/close
device,/encapsulated
set_plot,'x'




 FOR noi=0,fileno-1 DO BEGIN
      fits_read,fxx[noi],scube,hdr,exten_no=0
          fits_read,fxx_sdev[noi],scube_sdev,hdrv2,exten_no=0
     sz2d=size(scube) & ysize=sz2d[2]
  ;;; actual flux calibration here
      for iy=0,ysize-1 do begin
        scube[*,iy]=scube[*,iy]/(scale_rebin[*])
        scube_sdev[*,iy]=scube_sdev[*,iy]/(scale_rebin[*])
;        scube_var[*,iy]=scube_var[*,iy]*(flux1d_rebin[*]/fluxconvt)^2  ;; equation for inverse variance cube
        endfor

ppos1=0;strpos(fxx[noi],'eps_')
ppos2=strpos(fxx[noi],'.fits')
Namefxx=strmid(fxx[noi],ppos1,ppos2-ppos1)
 

  
       mwrfits,scube,Namefxx+'_fc.fits',hdr,/create
        mwrfits,scube_sdev,Namefxx+'_sdev_fc.fits',hdr,/create
fileout1[noi]=Namefxx+'_fc.fits'
fileout2[noi]=Namefxx+'_sdev_fc.fits'

 ENDFOR


ENDIF

;;;;;;;;

forprint,fileout1,textout=path+'obj_t_fc.list',/nocomment
forprint,fileout2,textout=path+'obj_sdev_t_fc.list',/nocomment

print,' @divid_flux.pro ---> flux calibrated  *_t_fc.fits successfully generated ... '

end


;;;
;; results flux calibrated / 6.53432e-18 = counts
