pro divid_tellu,pathsens,path,sensname,sensname_wave,masklist,mask_sdlist
;;;;  divide all science data by the sensitivty curve derived from
 ;;;; cali_telluric_flux.pro 
;;;; i.e, use this results
  ;mwrfits,senscurve,'sens_HD108519_1d.fits',header_sens,/create
  ;mwrfits,wave,'sens_HD108519_1d_wave.fits',header_sens,/create

;;;;  Note this program use spawn,'rm -rf '+path+'*_t.fits'   ;;; THIS WILL REMOVE ALL FILES THAT ENDS WITH *_t.FITS, BE CAREFUL !

;; if ~defined(clean) then begin
;; Print,'WARNING FOR YOU:  THIS PROGRAM WILL FORCE DELETE ALL FILES WITH *_T.FITS IN YOUR DATAPATH FIRST --  '
;; print,'-- Are you sure you want to do this ? If so, set /clean when calling divid_tellu. If not, backup your *_t.fits files first or' 
;; print,' delete the line that  begins with spawn rm -rf in divid_tellu'
;; stop
;; endif 

;;e.g.,
;path='/Users/yuantt/work/data/MOSFIRE/catlg/mask1_combined/shallowmask1_v3/' ; path for data to be telluric calibrated, direct output from MOSP
;path='/Users/yuantt/work/data/MOSFIRE/catlg/mask2_combined/'   ;;; path for data to be telluric calibrated, direct output from MOSPY
;pathsens='/Users/yuantt/work/data/MOSFIRE/catlg/codesample/'

path=path
pathsens=pathsens
sensname= sensname  ;'sens_HD108519_1d.fits'
sensname_wave= sensname_wave ;'sens_HD108519_1d_wave.fits'

fits_read,pathsens+sensname,sens1d,hd1d
fits_read,pathsens+sensname_wave,wavelen_star,hd1d



;; spawn,'rm -rf '+path+'*'+dele+'*_t.fits'
;; spawn,'rm -rf '+path+'*'+dele+'*_t_fc*.fits'

;fxx=file_search(path+'eps_K_m131225_0495-0513*.fits')   ;;1225-mask2
;fxx_var=file_search(path+'ivar_K_m131225_0495-0513*.fits')
;; maskroot=maskroot; 'eps_K_m131225_0519-0537*.fits'
;; maskroot_var=maskroot_var ;;'ivar_K_m131225_0519-0537*.fits' 
;; fxx=file_search(path+maskroot) ;;;1225-mask2
;; fxx_var=file_search(path+maskroot_var)

readcol,masklist,fxx,format='a'   ;; object list ;; electron/s
readcol,mask_sdlist,fxx_sdev,format='a'   ;;; standard deviation list ;; electron/s


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; NO NEED TO CHANGE SECTION ;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;              BELOW;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;npath=strlen(path) & nlen=strlen(fxx[0])

fileno = n_elements(fxx)
fileout1=fxx
fileout2=fxx
;;; check if star spectrum matches with the sciences, if not, then
;;; rebin star spectrum 

     fits_read,path+fxx[0],scube0,header_obj,exten_no=0
     spec1d_d=total(scube0,2,/nan)
     wavelen_obj=getwlcd(spec1d_d,header_obj)   ;;; moircsfire 
;;   spec2d_rebin=spec2d & spec2d_rebin[*,*]=!values.f_nan
;; mos_wave_trans,wavelen_obj,wavelen_star,sens1d, $
;;                     sens1d_rebin,header_obj,header_rebin

  sens1d_rebin=interpol(sens1d,wavelen_star,wavelen_obj) ; linear interpol without any options
  
;;;;;;; some manual work to push the Kband edge to above 2.4um and
;;;;;;; below 1.95um  
;;; FOr band K
man=where(wavelen_obj gt 23900. AND wavelen_obj le 24000.,ct1)
man1=where(wavelen_obj le 23900. AND wavelen_obj gt 23890,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(sens1d_rebin[man1])
sens1d_rebin[man] = manual
endif
man=where(wavelen_obj gt 19200. AND wavelen_obj le 19599.,ct1)
man1=where(wavelen_obj le 19630. AND wavelen_obj gt 19599,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(sens1d_rebin[man1])
sens1d_rebin[man] = manual
endif

;;; FOr band H
man=where(wavelen_obj gt 17949. AND wavelen_obj le 18210.,ct1)
man1=where(wavelen_obj le 17949. AND wavelen_obj gt 17926,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(sens1d_rebin[man1])
sens1d_rebin[man] = manual
endif
man=where(wavelen_obj gt 14501 AND wavelen_obj le 14663.,ct1)
man1=where(wavelen_obj le 14750. AND wavelen_obj gt 14663,ct2)
if ct1 gt 1 and ct2 gt 1 then begin
manual=median(sens1d_rebin[man1])
sens1d_rebin[man] = manual
endif


;;;;;;; some manual work to push the Kband edge to 2.4um





sens1d_rebin=sens1d_rebin/median(sens1d_rebin)  ;renormalize after rebinning
ind=where (sens1d_rebin eq 0,ctt)
if ctt gt 0 then sens1d_rebin[ind]=!values.f_nan

set_plot,'ps'
device,filename=path+'response.eps',/color

plot,wavelen_obj,sens1d_rebin,title='Final response curve divided to all data',thick=4
afff='Angs, sensitivity (normalized to 1)'
forprint,wavelen_obj,sens1d_rebin,textout=path+sensname+'_response.txt',comment=afff
device,/close
device,/encapsulated

;sens1d_rebin=median(sens1d_rebin,15)
set_plot,'x'

 FOR noi=0,fileno-1 DO BEGIN
     fits_read,path+fxx[noi],scube,hdr,exten_no=0
       ;   fits_read,fxx_var[noi],scube_var,hdrv,exten_no=0
          fits_read,path+fxx_sdev[noi],scube_sdev,hdrv2,exten_no=0

     sz2d=size(scube) & ysize=sz2d[2]
;stop
     
      for iy=0,ysize-1 do begin
        scube[*,iy]=scube[*,iy]/sens1d_rebin[*]
       ; scube_var[*,iy]=scube_var[*,iy]*sens1d_rebin[*]^2      
        scube_sdev[*,iy]=scube_sdev[*,iy]/sens1d_rebin[*]             
      endfor

ppos1=0;strpos(fxx[noi],'eps_')
ppos2=strpos(fxx[noi],'.fits')
Namefxx=strmid(fxx[noi],ppos1,ppos2-ppos1)

;; ppos1=0;strpos(fxx_var[noi],'ivar_')
;; ppos2=strpos(path+fxx[noi],'.fits')
;; Namefxx_sdev=strmid(path+fxx_sdev[noi],ppos1,ppos2-ppos1)

        mwrfits,scube,path+Namefxx+'_t.fits',hdr,/create
        mwrfits,scube_sdev,path+Namefxx+'_sdev_t.fits',hdr,/create
fileout1[noi]=path+Namefxx+'_t.fits'
fileout2[noi]=path+Namefxx+'_sdev_t.fits'
 ENDFOR


forprint,fileout1,textout=path+'obj_t.list',/nocomment
forprint,fileout2,textout=path+'obj_sdev_t.list',/nocomment

print,' @divid_tellu.pro ---> telluric corrected *_t.fits successfully generated ... '

end
