pro coadd2d_offset
device, decomposed=0
loadcolors

path1='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/shallowmask1_v3/2013dec25/K/'
path2='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/shallowmask1_v3/2013dec24/K/'

brightname1='shallowmask1_K_K_S10_SF_5751_eps_t_fc.fits';'eps_K_m140212_0164-0202_S27_t_fc.fits' ;; use star/bright galaxy frames to derive the spatial shift 
brightname2='shallowmask1_K_K_S10_SF_5751_eps_t_fc.fits';'eps_K_m140213_0343-0367_S27_t_fc.fits'

;shallowmask1_K_K_S26_SF_2765_eps_t_fc.fits
;intab='mask1_datav2.dat'

;; path='/Users/yuantt/work/data/MOSFIRE/catlg/mask2_combined/shallowmask2_v3_improvedFlat/'
;; brightname1='eps_K_m131224_0380-0398_S24_t_fc.fits'
;; brightname2='eps_K_m131225_0519-0537_S24_t_fc.fits'   ;; use star/bright galaxy frames to derive the spatial shift
;; intab='mask2_datav2.dat'

;; path='/Users/yuantt/work/data/MOSFIRE/catlg/mask3_combined/shallowmask3_v3_improvedFlat/'
;; brightname1='eps_K_m131224_0403-0421_S19_t_fc.fits'
;; brightname2='eps_K_m131225_0543-0561_S19_t_fc.fits'   ;; use star/bright galaxy frames to derive the spatial shift
;; intab='mask3_datav2.dat'

;; path='/Users/yuantt/work/data/MOSFIRE/catlg/mask4_combined/shallowmask4_v3_improvedFlat/'
;; brightname1='eps_K_m131224_0426-0429_S24_t_fc.fits'
;; brightname2='eps_K_m131225_0566-0580_S24_t_fc.fits'   ;; use star/bright galaxy frames to derive the spatial shift
;; intab='mask4_datav2.dat'


f1=path1+brightname1
f2=path2+brightname2

      fits_read,f1,image1,header_obj1,exten_no=0
      fits_read,f2,image2,header_obj2,exten_no=0

;;  spec1d_dattt=total(image1,2,/nan)
;;   wavedat=getwlcd(spec1d_dattt,header_obj1)   ;;; moircsfire 
;; ok=where(wavedat gt 20283. and wavedat le 20317.)


sz1=size(image1)  & sz2=size(image2)
if sz1[1] ne sz2[1] or sz1[2] ne sz2[2] then print, '  images have different sizes !!!!'
image1=image1[494:506,1:sz1[2]-2]
image2=image2[494:506,1:sz1[2]-2]

result = correl_images(image1,image2)
corrmat_analyze,result,xoffset,yoffset
print,xoffset,yoffset,' --- offset of'+brightname2+'...with resp. to the first image'+brightname1



  spec2dcut=image1 ;[where(wavex ge lowcut and wavex le hicut),*]
  space_profile=median(spec2dcut,dimension=1)
  plot,space_profile,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut=space_profile[x-10:x+10]
  xarray=findgen(21)-10.
  yfit=mpfitpeak(xarray,space_profile_cut,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray,space_profile_cut,psym=10;,xtickformat='(A1)'
  oplot,xarray,yfit,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  spec2d_cut=spec2dcut[*,cen-width:cen+width]
  spec1d1=total(spec2d_cut,2,/nan);/1.d-17
 
 spec2dcut=image2;[where(wavex ge lowcut and wavex le hicut),*]
  space_profile=median(spec2dcut,dimension=1)
  plot,space_profile,title='Space Profile of a ratining star spec.'
  print,'Click at a peak of the profile.'
  cursor,x,y
  wait,0.1
  space_profile_cut=space_profile[x-10:x+10]
  xarray=findgen(21)-10.
  yfit=mpfitpeak(xarray,space_profile_cut,A,sigma=sigma,nterms=4,/positive,errmsg=errmsg)
  plot,xarray,space_profile_cut,psym=10;,xtickformat='(A1)'
  oplot,xarray,yfit,color=2
  wait,1.  
  x+=a[1]
  cen=x
  width=a[2]
  print,'center & FWHM ',cen,width*2.3548
  spec2d_cut=spec2dcut[*,cen-width:cen+width]
  spec1d2=total(spec2d_cut,2,/nan);/1.d-17
 
plot,spec1d1/spec1d2,title=' Day1 / Day2'
print,'median flux of day1 / day2',median(spec1d1)/median(spec1d2)
print,'percentage median flux of day1 / day2',abs(median(spec1d1)-median(spec1d2))/max([median(spec1d1),median(spec1d2)])

;coaddimage=(image1+frac_pix_shift(image2,xoffset,yoffset))/2

;mwrfits,coaddimage,path+'test.fits',header_obj2
;; results
;;; offset = 0 for all nights !!!!!!!!!!!
stop
end



;pro fit1dmos_flux,path,pathdat,maskname,intab,maskroot,maskroot_var,textpos,ps=ps,first=first


;;mask3
;eps_K_m131225_0543-0561_S03_t_fc.fits
;eps_K_m131224_0403-0421_S16_t_fc.fits       
pro add2d
;;;; 
;path2='/Users/yuantt/work/data/MOSFIRE/catlg/Feb2014/archive/Masks_120314_oldDRP/Hbandmask1/2014feb12/'
;path1='/Users/yuantt/work/data/MOSFIRE/catlg/Feb2014/archive/Masks_120314_oldDRP/Hbandmask1/2014feb10/'

;path2='/Users/yuantt/work/data/MOSFIRE/catlg/Feb2014/archive/Masks_120314_oldDRP/KbandLargeArea3/2014feb13/'
path1='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/shallowmask1_v3/2013dec25/K/'
path2='/Users/yuantt/work/data/MOSFIRE/catlg/NDRP/December2013/shallowmask1_v3/2013dec24/K/'

;textpos='eps_H_S'
;textpos='eps_K_m140212_0164-0202_S'   ;;; unique string character in the science frame filename used to locate the slitlet ID
;textpos='eps_H_m140212_0070-0116_S'   ;;; unique string character in the science frame filename used to locate the slitlet ID

paths=[path1,path2]
masknum=1

objlist_fc_nt1=path1+'obj_t_fc.list'
objlist_std_nt1=path1+'obj_sdev_t_fc.list' 
objlist_fc_nt2=path2+'obj_t_fc.list'
objlist_std_nt2=path2+'obj_sdev_t_fc.list' 

readcol,objlist_fc_nt1,fxx_nt1,format='a'   ;; object list ;; electron/s
readcol,objlist_std_nt1,fxx_nt1_std,format='a'   ;; object list ;; electron/s
readcol,objlist_fc_nt2,fxx_nt2,format='a'   ;; object list ;; electron/s
readcol,objlist_std_nt2,fxx_nt2_std,format='a'   ;; object list ;; electron/s




xoff=[-1,1] & yoff=[-1,0]

norm_fluxf1=1
norm_fluxf2=0

fluxf1=1/0.40133988 ;;;  if use the factor on night 1, night1*fluxf1
fluxf2=3.52;3.864 ;  ;; if use on night 2

for moi = 0, masknum-1 do begin
print,'  coadd mask  -' 


fileno = n_elements(fxx_nt1)
         for noi=0, fileno-1 do begin
ppos1=0
ppos2=strpos(fxx_nt1[noi],'.fits')
Namefxx_nt1=strmid(fxx_nt1[noi],ppos1,ppos2-ppos1)

ppos1=0
ppos2=strpos(fxx_nt1_std[noi],'.fits')
Namefxx_nt1_std=strmid(fxx_nt1_std[noi],ppos1,ppos2-ppos1)

     fits_read,fxx_nt1[noi],image_nt1,hdr,exten_no=0
     fits_read,fxx_nt1_std[noi],image_nt1_std,hdrv,exten_no=0

textpos='_K_K_S'
stlen1=strlen(textpos)
           pppos1=strpos(fxx_nt1[noi],textpos)
           slitnum_st=strmid(fxx_nt1[noi],pppos1+stlen1,2)


;stop
           slitnum=STR2NUM(slitnum_st)*1
               slitnum_compare=strmid(fxx_nt2[noi],pppos1+stlen1,2)

                matchid=where(slitnum_compare eq slitnum,ct1)
if ct1 ne 1 then stop
        ;           if ct1 gt 0 then begin
                     ;    fits_read,fxx_nt2[matchid[0]],image_nt2,hdr2,exten_no=0
                     ;    fits_read,fxx_nt2_std[matchid[0]],image_nt2_std,hdrv2,exten_no=0
                         fits_read,fxx_nt2[noi],image_nt2,hdr2,exten_no=0
                         fits_read,fxx_nt2_std[noi],image_nt2_std,hdrv2,exten_no=0
                     
                       xoffset=xoff[moi] & yoffset=yoff[moi]
                       if xoffset ge 1 or yoffset ge 1 then begin
                           image_nt2=frac_pix_shift(image_nt2,xoffset,yoffset)
                           image_nt2_std=frac_pix_shift(image_nt2_std,xoffset,yoffset)
                        endif
 if norm_fluxf1 eq 1 then begin
                           imagecoadd=(image_nt1*fluxf1+image_nt2)/2.
                           imagecoadd_std=sqrt((image_nt1_std*fluxf1)^2+(image_nt2_std)^2)/2.
                          
                          endif
 if norm_fluxf2 eq 1 then begin
                           imagecoadd=(image_nt1+image_nt2*fluxf2)/2.
                           imagecoadd_std=sqrt((image_nt1_std)^2+(image_nt2_std*fluxf2)^2)/2.
 
   endif


        mwrfits,imagecoadd,Namefxx_nt1+'_coadd.fits',hdr,/create
        mwrfits,imagecoadd_std,Namefxx_nt1_std+'_coadd.fits',hdr,/create

                   ;; endif else begin
                   ;;  print,' stopped ---> no object matching the multiple observations '
                   ;;  stop
                   ;; endelse 


         endfor
endfor 

print,'  -- end'
stop
end
